/*
 * Copyright (C) 2011 Rhegium Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.rhegium.internal.modules;

public abstract class PluginThreadContext<T> {
	private final PluginClassLoader pluginClassLoader;

	public PluginThreadContext(final PluginClassLoader pluginClassLoader) {
		this.pluginClassLoader = pluginClassLoader;
	}

	public T execute() {
		final ClassLoader originalClassLoader = Thread.currentThread()
				.getContextClassLoader();

		try {
			Thread.currentThread().setContextClassLoader(pluginClassLoader);
			return run();

		} finally {
			Thread.currentThread().setContextClassLoader(originalClassLoader);
		}
	}

	protected abstract T run();

}
